/*=========================================================================
*
*  Copyright NumFOCUS
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*         http://www.apache.org/licenses/LICENSE-2.0.txt
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*=========================================================================*/
#ifndef sitkComplexToPhaseImageFilter_h
#define sitkComplexToPhaseImageFilter_h

/*
 * WARNING: DO NOT EDIT THIS FILE!
 * THIS FILE IS AUTOMATICALLY GENERATED BY THE SIMPLEITK BUILD PROCESS.
 * Please look at sitkImageFilterTemplate.h.in to make changes.
 */

#include <memory>

#include "sitkBasicFilters.h"
#include "sitkImageFilter.h"

namespace itk::simple {

    /**\class ComplexToPhaseImageFilter
\brief Computes pixel-wise the modulus of a complex image.


\sa itk::simple::ComplexToPhase for the procedural interface
\sa itk::ComplexToPhaseImageFilter for the Doxygen on the original ITK class.
     */
    class SITKBasicFilters_EXPORT ComplexToPhaseImageFilter : public ImageFilter {
    public:
      using Self = ComplexToPhaseImageFilter;

      /** Destructor */
      virtual ~ComplexToPhaseImageFilter();

      /** Default Constructor that takes no arguments and initializes
       * default parameters */
      ComplexToPhaseImageFilter();

      /** Define the pixels types supported by this filter */
      using PixelIDTypeList = ComplexPixelIDTypeList;


      /** Name of this class */
      std::string GetName() const { return std::string ("ComplexToPhaseImageFilter"); }

      /** Print ourselves out */
      std::string ToString() const;


      /** Execute the filter on the input image */
#ifndef SWIG
      Image Execute ( Image&& image1 );
#endif
      Image Execute ( const Image& image1 );

    private:

      /** Setup for member function dispatching */

      using MemberFunctionType = Image (Self::*)( const Image& image1 );
      template <class TImageType> Image ExecuteInternal ( const Image& image1 );


      friend struct detail::MemberFunctionAddressor<MemberFunctionType>;

      std::unique_ptr<detail::MemberFunctionFactory<MemberFunctionType> > m_MemberFactory;



      bool m_InPlace{false};
    };

    /**\
     * \brief Computes pixel-wise the modulus of a complex image.
     *
     * This function directly calls the execute method of ComplexToPhaseImageFilter
     * in order to support a procedural API
     *
     * \sa itk::simple::ComplexToPhaseImageFilter for the object oriented interface
     * @{
     */
#ifndef SWIG
     SITKBasicFilters_EXPORT Image ComplexToPhase ( Image&& image1 );
#endif
     SITKBasicFilters_EXPORT Image ComplexToPhase ( const Image& image1 );

     /** @} */
}
#endif
